      SUBROUTINE AFJ0C(BR,BI,CR,CI,N,IERR)
      DIMENSION BR(N),BI(N),CR(N),CI(N)
      INTEGER N,IERR,I
      REAL BR,BI,CR,CI,W,UR,UI,BRI,BII,CRI,CII,
     1B,SB,C,SC,S,SYS056,SYS052,SQRT,CABS,SIGN
      COMPLEX CB,CC,CMPLX
C     SYS056 = SYS055
      DATA  SYS056 /1.175495E-38/
      DATA  SYS052/1.1920928E-7/
      W=8.*SYS052
      IERR=0
      CR(1)=1.
      CI(1)=0.
      UR=1.
      UI=0.
      IF(N.EQ.1) GO TO 7
      DO 4 I=2,N
      BRI=BR(I)
      BII=BI(I)
      CRI=CR(I)
      CII=CI(I)
      CB=CMPLX(BRI,BII)
      B=CABS(CB)
      SB=SQRT(B)
      CC=CMPLX(CRI,CII)
      C=CABS(CC)
      SC=SQRT(C)
      S=SB*SC
      BR(I)=S
      IF(B.EQ.0..AND.C.EQ.0.) GO TO 2
      IF(S.EQ.0.) GO TO 6
      SB=BRI/B
      SC=CRI/C
      IF (ABS(SB-SC).GT.( ABS(SB)+ ABS(SC))*W) GO TO 5
      SB=0.
      SC=0.
      IF(BII.NE.0.) SB=SIGN(1.,BII)
      IF(CII.NE.0.) SC=-SIGN(1.,CII)
      IF(SB.NE.SC) GO TO 5
      IF(IERR.EQ.68) GO TO 4
      S=1./S
      CRI=CRI*S
      CII=CII*S
      C=AMAX1( ABS(CRI), ABS(CII))
      B=AMAX1( ABS(UR), ABS(UI))
      IF(C*SYS056*B.LT.0.5) GO TO 1
      IERR=68
      GO TO 4
    1 BRI=UR*CRI-UI*CII
      BII=UI*CRI+UR*CII
      GO TO 3
    2 BRI=1.
      BII=0.
    3 CR(I)=BRI
      CI(I)=BII
      UR=BRI
      UI=BII
      IF(UR.EQ.0..AND.UI.EQ.0.) IERR=68
    4 CONTINUE
      GO TO 7
    5 IERR=66
      GO TO 7
    6 IERR=67
    7 IF(IERR.NE.0) CALL UTAF12(IERR,4)
      RETURN
      END
